Imports System.Xml
Imports System.Xml.Serialization
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports System.IO
Imports System.Collections.Generic
Public Class SalesLeadPush
    Public Function SerializeXML() As XmlDocument

        Dim SiteID = 3214

        Dim sqlCon As New SqlConnection(ConfigurationManager.ConnectionStrings("salesPush").ConnectionString)
        Dim CmdTxt As String = "getSalesLeads"
        Dim SqlCmd As New SqlCommand(CmdTxt, sqlCon)
        SqlCmd.CommandType = CommandType.StoredProcedure
        Dim sqlDS As New DataSet
        Dim sqlDA As New SqlDataAdapter(SqlCmd)

        'Set up Serializer
        Dim mStream As MemoryStream = New MemoryStream
        Dim xns As XmlSerializerNamespaces = New XmlSerializerNamespaces
        Dim mySerializer As New XmlSerializer(GetType(SalesTools.SalesLead))
        Dim xmlDoc As New XmlDocument

        'Set up object
        Dim oSalesTools As New SalesTools.SalesLead

        xns.Add(String.Empty, String.Empty)
        sqlDA.Fill(sqlDS)

        Dim i As Integer = 0
        Dim sLeadID As Integer = 0
        Dim sContactID As Integer = 0

        For Each Row As DataRow In sqlDS.Tables(0).Rows
            Dim oContact As New SalesTools.Contact
            Dim oVehicleList As New SalesTools.Vehicle
            Dim oLead As New SalesTools.Lead

            oContact.ContactID = CInt(Row("ContactID").ToString)
            oContact.AddressLine1 = Row("contactAddressLine1").ToString
            oContact.City = Row("contactCity").ToString
            oContact.State = Row("contactState").ToString
            oContact.Postal = Row("contactPostal").ToString
            oContact.FullName = Row("contactFullName").ToString
            oContact.FirstName = Row("contactFirstName").ToString
            oContact.LastName = Row("contactLastName").ToString
            oContact.Email = Row("contactEmail").ToString
            oContact.Phone = Row("contactPhone").ToString
            oContact.BestContactMethod = Row("contactBestContactMethod").ToString
            oContact.BestContactTime = Row("contactBestContactTime").ToString

            oVehicleList.VehicleID = CInt(Row("vehicleID").ToString)
            oVehicleList.Make = Row("vehicleMake").ToString
            oVehicleList.Model = Row("vehicleModel").ToString
            oVehicleList.Year = Row("vehicleYear").ToString
            oVehicleList.VIN = Row("vehicleVIN").ToString
            oVehicleList.Color = Row("vehicleColor").ToString
            oVehicleList.BasePrice = Row("vehicleBasePrice").ToString
            oVehicleList.SRP = Row("vehicleSRP").ToString

            oContact.Vehicle = oVehicleList

            oLead.Contact = oContact

            oLead.LeadID = CInt(Row("LeadID").ToString)
            oLead.ContactID = CInt(Row("ContactID").ToString)
            oLead.VehicleID = CInt(Row("VehicleID").ToString)
            oLead.SiteID = SiteID
            oSalesTools.Leads.Add(oLead)

        Next
        mySerializer.Serialize(mStream, oSalesTools, xns)
        SqlCmd.Connection.Close()
        SqlCmd.Dispose()

        xmlDoc.LoadXml(UTF8ByteArrayToString(mStream.ToArray()))

        Dim ws As New SalesLeadListen.SalesLeadListen
        Dim Result As New XmlDocument
        Result.LoadXml(ws.LoadLeads(xmlDoc).OuterXml)

        Return Result
    End Function

    Private Function UTF8ByteArrayToString(ByVal characters As Byte()) As String

        Dim encoding As New UTF8Encoding()
        Dim constructedString As String = encoding.GetString(characters)
        Return (constructedString)
    End Function

    Private Function StringToUTF8ByteArray(ByVal pXmlString As String) As Byte()
        Dim encoding As New UTF8Encoding()
        Dim byteArray As Byte() = encoding.GetBytes(pXmlString)
        Return byteArray
    End Function

End Class
